#include "deletetestwidget.h"
#include "ui_deletetestwidget.h"
#include <QDebug>
#include <QSqlQuery>


deletetestwidget::deletetestwidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::deletetestwidget)
{
    ui->setupUi(this);
    returnButton = new QPushButton("Назад", this);
    returnButton->show();
    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(deleteTest()));
    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(Refresh()));
    connect(ui->testView, SIGNAL(doubleClicked(const QModelIndex &)), this, SLOT(onLVdoubleClicked(const QModelIndex &)));

    ui->testView->setEditTriggers(QListView::NoEditTriggers);

    QStringListModel* strListModel = new QStringListModel(ui->testView);
    QStringList *strList = new QStringList();
    QSqlQueryModel *queryModel = new QSqlQueryModel(this);
    queryModel->setQuery("SELECT name FROM tests",db);
    for(int i = 0; i < queryModel->rowCount(); i++ )
    {
        strList->push_back(queryModel->index(i,0).data().toString());
    }
    strListModel->setStringList(*strList);
    ui->testView->setModel(strListModel);
}

deletetestwidget::~deletetestwidget()
{
    delete ui;
}

void deletetestwidget::receiveDataBase(const QSqlDatabase &p_db)
{
    db = p_db;
}

void deletetestwidget::deleteTest()
{


    QSqlQueryModel *model = new QSqlQueryModel();
    model->setQuery(QSqlQuery("DELETE FROM tests WHERE name = '" + test_name + "';",db));
    if(model->query().size() != 0 )
    {
        qDebug() << model->query().lastError().text();
        message = new QMessageBox();
        message->setText("Тест " + test_name + " успешно удален");
        message->show();
    }
    else
    {
        err = new QErrorMessage();
        err->showMessage("Такого теста не существует");
    }
}

void deletetestwidget::Refresh()
{
    QStringListModel* strListModel = new QStringListModel(ui->testView);
    QStringList *strList = new QStringList();
    QSqlQueryModel *queryModel = new QSqlQueryModel(this);
    queryModel->setQuery("SELECT name FROM tests",db);
    for(int i = 0; i < queryModel->rowCount(); i++ )
    {
        strList->push_back(queryModel->index(i,0).data().toString());
    }
    strListModel->setStringList(*strList);
    ui->testView->setModel(strListModel);
}

void deletetestwidget::onLVdoubleClicked(const QModelIndex &inx)
{
    test_name = inx.data().toString();
    qDebug() << test_name;
    QSqlQueryModel *model = new QSqlQueryModel();
    model->setQuery(QSqlQuery("SELECT name FROM tests WHERE name = " + test_name, db));
    qDebug() << test_name;
}
